// Setup.cpp : implementation file
//

#include "stdafx.h"
#include "PlugSample.h"
#include "Setup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CBPOParamters *pBPOParameters;
extern SAMPLEPARAM sampleparamdata; 
extern PLUGINBUSLIST buslist[1]; //Packet List 
/////////////////////////////////////////////////////////////////////////////
// CSetup dialog


CSetup::CSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetup)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetup)
	DDX_Control(pDX, IDC_COMBO2, m_combo1);
	DDX_Control(pDX, IDC_COMBO1, m_combo);
	DDX_Control(pDX, IDC_BUTTON2, m_clrbtn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetup, CDialog)
	//{{AFX_MSG_MAP(CSetup)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetup message handlers

BOOL CSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	initParam();
	initChannel();	
	initSel();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSetup::initParam()
{
	channelIndex = sampleparamdata.index;
	clkIndex = sampleparamdata.clk;
	m_clrbtn.SetFaceColor(sampleparamdata.clr);
}

void CSetup::initChannel()
{
	int nIndex = 0;
	CBPOSubItem* pSubItemA = NULL;	
	int count = pBPOParameters->m_nBusSubCount;
	for(int i = 0;i < count;i++)
	{
		pSubItemA = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(i);
		nIndex = m_combo.AddString(pSubItemA->m_strItemName);
		m_combo.SetItemData(nIndex,pSubItemA->m_nItemChannel);
		nIndex = m_combo1.AddString(pSubItemA->m_strItemName);
		m_combo1.SetItemData(nIndex,pSubItemA->m_nItemChannel);
	}
}
void CSetup::initSel()
{
	if(channelIndex < 0 || clkIndex < 0)
	{
		m_combo.SetCurSel(1);
		m_combo1.SetCurSel(0);
		
		sampleparamdata.clk = m_combo1.GetItemData(1);
		sampleparamdata.index = m_combo.GetItemData(0);
		channelIndex = sampleparamdata.index;
		clkIndex = sampleparamdata.clk;

		return;
	}

	if(GetSelIndex(channelIndex) >= 0)
	{
		m_combo.SetCurSel(GetSelIndex(channelIndex));
	}
	else
	{
		m_combo.SetCurSel(1);
	}

	if(GetSelIndex(clkIndex) >= 0)
	{
		m_combo1.SetCurSel(GetSelIndex(clkIndex));
	}
	else
	{
		m_combo1.SetCurSel(0);
	}
}
int CSetup::GetSelIndex(int nIndex)
{
	int nData = 0;	
	int count = m_combo1.GetCount();
	for(int i = 0;i < count;i++)
	{
		nData = m_combo1.GetItemData(i);
		if(nIndex == nData)return i;
	}
	return -1;
}
void CSetup::defaultParam()
{
	clkIndex = 0;
	channelIndex = 1;
	m_combo.SetCurSel(channelIndex);
	m_combo1.SetCurSel(clkIndex);
	m_clrbtn.SetFaceColor(RGB(45,163,128));	
	m_clrbtn.ReDrawButton();
}

bool CSetup::storeParam()
{

	if(m_combo1.GetCurSel() == m_combo.GetCurSel())
	{
		AfxMessageBox("Clock channel can't be the same as Data channel");
		return false;
	}

	int nSel = 0;
	nSel = m_combo1.GetCurSel();
	sampleparamdata.clk = m_combo1.GetItemData(nSel);

	nSel = m_combo.GetCurSel();
	sampleparamdata.index = m_combo.GetItemData(nSel);

	sampleparamdata.clr = 	m_clrbtn.GetFaceColor();
	buslist[1].clr = m_clrbtn.GetFaceColor();//Set the color of the Packet List. 
	buslist[1].bShow = true;//After the Packet List is set, the result will be displayed. 
	return true;
}

void CSetup::OnButton4() 
{
	// TODO: Add your control notification handler code here
	defaultParam();
	
}

void CSetup::OnOK() 
{
	// TODO: Add extra validation here
	if(storeParam())
		CDialog::OnOK();
}
