// olorButton.cpp : implementation file
//

#include "stdafx.h"
#include "olorButton.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ColorButton

ColorButton::ColorButton()
{
	m_clrFaceColor = RGB(0,128,255);
	m_bButtonStatus = TRUE;
	m_bButtonDownStatus = FALSE;
}

ColorButton::~ColorButton()
{
}


BEGIN_MESSAGE_MAP(ColorButton, CButton)
	//{{AFX_MSG_MAP(ColorButton)
	ON_WM_LBUTTONDOWN()
	ON_WM_ENABLE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ColorButton message handlers

void ColorButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	// TODO: Add your code to draw the specified item
	CDC dc;	
	dc.Attach(lpDrawItemStruct->hDC);	
	CRect rect = lpDrawItemStruct->rcItem;
	UINT nIndex = lpDrawItemStruct->itemID;	
	//draw two rectangles, one for each row column	
	CRect rectLeft = CRect(rect.left,rect.top,rect.right - rect.Width()/4,rect.bottom);
	CRect rectRight = CRect(rectLeft.right,rect.top,rect.right,rect.bottom);
	CString  str = "...";
	COLORREF clrtemp = RGB(0,0,0);
	dc.FillSolidRect(rectLeft,m_clrFaceColor);
	dc.FillSolidRect(rectRight,RGB(192,192,192));	
	CPen			Pen1;
	CPen			Pen2;
	Pen1.CreatePen(PS_SOLID,1,RGB(0,0,0));
	Pen2.CreatePen(PS_SOLID,1,RGB(255,255,255));
	if(m_bButtonStatus == TRUE)
	{
		dc.SelectObject(Pen1);
		dc.MoveTo(rect.right-1,rect.top);
		dc.LineTo(rect.right-1,rect.bottom);
		dc.MoveTo(rect.left,rect.bottom-1);
		dc.LineTo(rect.right,rect.bottom-1);

	dc.SelectObject(Pen2);
		dc.MoveTo(rect.left,rect.top);
		dc.LineTo(rect.left,rect.bottom);
		dc.MoveTo(rect.left,rect.top);
		dc.LineTo(rect.right,rect.top);
		if(m_bButtonDownStatus == TRUE)
		{
			dc.SelectObject(Pen2);
			dc.MoveTo(rect.right-1,rect.top);
			dc.LineTo(rect.right-1,rect.bottom);
			dc.MoveTo(rect.left,rect.bottom-1);
			dc.LineTo(rect.right,rect.bottom-1);
			
			dc.SelectObject(Pen1);
			dc.MoveTo(rect.left,rect.top);
			dc.LineTo(rect.left,rect.bottom);
			dc.MoveTo(rect.left,rect.top);
			dc.LineTo(rect.right,rect.top);
		}
	dc.SetBkMode(TRANSPARENT);
	dc.SetTextColor(clrtemp);
	dc.DrawText(str,rectRight,DT_CENTER | DT_SINGLELINE);
	}

	if(m_bButtonStatus == FALSE)
	{
		CBrush brush(HS_DIAGCROSS,RGB(128,128,128));
		CPen pen(PS_NULL,0,RGB(0,0,0));
		dc.SelectObject(&pen);
		dc.SelectObject(&brush);
		dc.SetBkMode(TRANSPARENT);
		dc.Rectangle(rect);

		dc.SelectObject(Pen2);
		dc.MoveTo(rect.right-1,rect.top);
		dc.LineTo(rect.right-1,rect.bottom);
		dc.MoveTo(rect.left,rect.bottom-1);
		dc.LineTo(rect.right,rect.bottom-1);

		dc.SelectObject(Pen1);
		dc.MoveTo(rect.left,rect.top);
		dc.LineTo(rect.left,rect.bottom);
		dc.MoveTo(rect.left,rect.top);
		dc.LineTo(rect.right,rect.top);

		dc.SetBkMode(TRANSPARENT);
		dc.SetTextColor(RGB(128,128,128));
		dc.DrawText(str,rectRight,DT_CENTER | DT_SINGLELINE);
	}
	//write the initial property value in the second rectangle	
	dc.Detach();
	
}

void ColorButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_bButtonDownStatus = TRUE;
	ReDrawButton();
	CColorDialog              clrDialog(m_clrFaceColor);
	COLORREF				  pclr[16] = 
	{		RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),
			RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),
			RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),
			RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),RGB(255,255,255),
	};

	bool  bSucess=FinBaseColor(m_clrFaceColor);
	if (!bSucess)
		pclr[0]=m_clrFaceColor;
	clrDialog.m_cc.lpCustColors = pclr;
	if(clrDialog.DoModal() == IDOK)
	{
		m_clrFaceColor = clrDialog.GetColor();
	}	
	m_bButtonDownStatus = FALSE;
	ReDrawButton();//::InvalidateRect(m_hWnd,NULL,false);
}

bool ColorButton::SetFaceColor(COLORREF clr)
{
	m_clrFaceColor = clr;
	return true;
}

COLORREF ColorButton::GetFaceColor()
{
	return m_clrFaceColor;
}

void ColorButton::ReDrawButton()//I2C
{
	::InvalidateRect(m_hWnd,NULL,false);
}

void ColorButton::OnEnable(BOOL bEnable) 
{
	
	// TODO: Add your message handler code here
	m_bButtonStatus = bEnable;
	ReDrawButton();//CButton::OnEnable(bEnable);
}

void ColorButton::ChangeAddBarColor(int count)
{
	COLORREF				  pcolor[24] = 
	{		RGB(0,128,255),RGB(255,255,0),RGB(128,0,255),RGB(0,128,0),
			RGB(0,128,128),RGB(0,255,128),RGB(0,0,0),RGB(0,255,0),//RGB(255,255,128),
			RGB(128,0,0),RGB(128,0,128),RGB(0,0,255),RGB(128,128,0),//RGB(0,255,255),
			RGB(128,128,128),RGB(128,128,255),RGB(128,255,0),RGB(255,128,255),
			RGB(128,255,255),RGB(255,0,0),RGB(255,0,128),RGB(128,255,128),
			RGB(255,128,0),RGB(255,128,128),RGB(255,0,255),RGB(255,255,255),//RGB(255,255,0),
			
			};
	if(count<24)
		m_clrFaceColor = pcolor[count];
	else
		m_clrFaceColor = RGB(rand(),rand(),rand());
}

bool ColorButton::FinBaseColor(COLORREF clr)
{
	COLORREF temp=RGB(0,0,0);
	COLORREF				  pBaseclr[48] = 
	{		RGB(255,128,128),RGB(255,255,128),RGB(128,255,128),RGB(0,255,128),RGB(128,255,255),RGB(0,128,255),RGB(255,128,192),RGB(255,128,255),
	RGB(255,0,0),	 RGB(255,255,0),  RGB(128,255,0),  RGB(0,255,64), RGB(0,255,255),  RGB(0,128,192),RGB(128,128,192),RGB(255,0,255),
	RGB(128,64,64),	 RGB(255,128,64), RGB(0,255,0),	   RGB(0,128,128),RGB(0,64,128),   RGB(128,128,255),RGB(128,0,64), RGB(255,0,128),
	RGB(128,0,0),	 RGB(255,128,0),  RGB(0,128,0),	   RGB(0,128,64), RGB(0,0,255),    RGB(0,0,160),    RGB(128,0,128),RGB(128,0,255),
	RGB(64,0,0),	 RGB(128,64,0),	  RGB(0,64,0),	   RGB(0,64,64),  RGB(0,0,128),    RGB(0,0,64),     RGB(64,0,64),  RGB(64,0,128),
	RGB(0,0,0),		 RGB(128,128,0),  RGB(128,128,64), RGB(128,128,128),RGB(64,128,128),RGB(192,192,192),RGB(64,0,64), RGB(255,255,255),
	};	
	for(int i = 0; i <48; i++)
	{	
		temp = pBaseclr[i];
		if(temp==clr)
		{
			return true;
		}	
	}
	return false;;
}