// IICSetupPage1.cpp : implementation file
//

#include "stdafx.h"
#include "PlugIIC.h"
#include "IICSetupPage1.h"
#include "IICSetupCustomDlg.h"
#include "IIC_PARAM_DATA.h" //iic paramters
#include "IICSetupSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CIICSetupPage1 dialog
#define DEFAULT_START_COLOR RGB(102,204,204)
#define DEFAULT_ADDRESS_COLOR RGB(249,114,29)
#define DEFAULT_READ_COLOR RGB(60,125,253)
#define DEFAULT_WRITE_COLOR RGB(230,73,89)
#define DEFAULT_DATA_COLOR RGB(51,204,51)
#define DEFAULT_ACK_COLOR RGB(255,0,128)
#define DEFAULT_END_COLOR RGB(204,0,0)
#define DEFAULT_NACK_COLOR RGB(249,117,142)
#define DEFAULT_DATAACK_COLOR RGB(138,206,137)
#define DEFAULT_DATANACK_COLOR RGB(171,203,95)


#define DEFAULT_SDA_CHANNEL 0
#define DEFAULT_SCL_CHANNEL 1
#define DEFAULT_BUS_NAME "IIC DATA"
#define DEFAULT_TEXT_MODE 1//HEX
#define MAX_BUS_NAME 50

#include "BusData.h"
extern IICPARAM iicparamdata;
extern CBPOParamters *pBPOParameters;
extern PLUGINSTATUS pluginstatus;
extern CString MessageStringTable(UINT ID);
/////////////////////////////////////////////////////////////////////////////
// CIICSetupPage1 property page

IMPLEMENT_DYNCREATE(CIICSetupPage1, CPropertyPage)

CIICSetupPage1::CIICSetupPage1() : CPropertyPage(CIICSetupPage1::IDD)
{
	//{{AFX_DATA_INIT(CIICSetupPage1)
	
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;
	m_bActive=false;

	m_nSdaChannel =  iicparamdata.SdaNameIndex;
	m_nSclChannel = iicparamdata.SclNameIndex;
	m_strBusName.Empty();
}
CIICSetupPage1::CIICSetupPage1( UINT IDD, UINT nIDCaption): CPropertyPage(IDD)
{
	//{{AFX_DATA_INIT(CIICSetupPage1)
	
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;
	m_bActive=false;
	m_nSdaChannel = iicparamdata.SdaNameIndex;
	m_nSclChannel = iicparamdata.SclNameIndex;
	m_strBusName.Empty();
}
CIICSetupPage1::~CIICSetupPage1()
{
}

void CIICSetupPage1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIICSetupPage1)
	DDX_Control(pDX, IDC_IIC_EDIT_BUS_NAME, m_edtBusName);
	DDX_Control(pDX, IDC_IIC_COMBO_SDA, m_comboSda);
	DDX_Control(pDX, IDC_IIC_COMBO_SCL, m_comboScl);
	DDX_Control(pDX, IDC_IIC_CLR_WRITE, m_clrbtnWrite);
	DDX_Control(pDX, IDC_IIC_CLR_START, m_clrbtnStart);
	DDX_Control(pDX, IDC_IIC_CLR_READ, m_clrbtnRead);
	DDX_Control(pDX, IDC_IIC_CLR_END, m_clrbtnEnd);
	DDX_Control(pDX, IDC_IIC_CLR_DATA, m_clrbtnData);
	DDX_Control(pDX, IDC_IIC_CLR_ACK, m_clrbtnAck);
	DDX_Control(pDX, IDC_IIC_CLR_ADDRESS, m_clrbtnAddress);
	DDX_Control(pDX, IDC_IIC_CLR_NACK, m_clrbtnNAck);
	DDX_Control(pDX, IDC_IIC_CLR_NACK, m_clrbtnNAck);
	DDX_Control(pDX, IDC_IIC_CLR_DATAACK, m_clrbtnDataAck);
	DDX_Control(pDX, IDC_IIC_CLR_DATANACK, m_clrbtnDataNack);
	DDX_Control(pDX, IDC_IIC_CLR_REGADDR, m_clrbtnREGADDR);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIICSetupPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CIICSetupPage1)
	ON_BN_CLICKED(IDC_IIC_CUSTOM, OnIicCustom)
	ON_CBN_SELCHANGE(IDC_IIC_COMBO_SDA, OnSelchangeIicComboSda)
	ON_CBN_SELCHANGE(IDC_IIC_COMBO_SCL, OnSelchangeIicComboScl)

	ON_WM_PAINT()

		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CIICSetupPage1::OnInitDialog() 
{
	CDialog::OnInitDialog();
	InitI2CParameter();
	InitSelectChannel();
	InitColor();
	InitBus();	
	// TODO: Add extra initialization here
	m_bActive=true;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CIICSetupPage1::InitI2CParameter()
{
	m_clrStart = iicparamdata.clrStart;
	m_clrData = iicparamdata.clrData;
	m_clrRead = iicparamdata.clrRead;
	m_clrWrite = iicparamdata.clrWrite;
	m_clrAck = iicparamdata.clrAck;
	m_clrEnd = iicparamdata.clrEnd;
	m_strBusName =pBPOParameters->m_strBusName;//GetBusName();
	m_clrNAck= iicparamdata.m_clrSpecBuscolor2;
	m_clrAddress= iicparamdata.m_clrSpecBuscolor1;

	
	m_clrDataAck= iicparamdata.m_clrSpecBuscolor3;
	m_clrDataNack= iicparamdata.m_clrSpecBuscolor4;
	
}

void CIICSetupPage1::InitBus()
{
	m_edtBusName.SetWindowText(m_strBusName);

}
void CIICSetupPage1::InitColor()
{
	m_clrbtnStart.SetFaceColor(m_clrStart);
	m_clrbtnRead.SetFaceColor(m_clrRead);
	m_clrbtnWrite.SetFaceColor(m_clrWrite);
	m_clrbtnData.SetFaceColor(m_clrData);
	m_clrbtnAck.SetFaceColor(m_clrAck);
	m_clrbtnEnd.SetFaceColor(m_clrEnd);
	m_clrbtnAddress.SetFaceColor(m_clrAddress);
	m_clrbtnNAck.SetFaceColor(m_clrNAck);

	m_clrbtnDataAck.SetFaceColor(m_clrDataAck);
	m_clrbtnDataNack.SetFaceColor(m_clrDataNack);
	m_clrbtnREGADDR.SetFaceColor(iicparamdata.m_clrSpecBuscolor5);
}

void CIICSetupPage1::InitSelectChannel()
{
	CBPOSubItem* pSubItemA = NULL;	

	int count;
	int i  = 0,index = 0,id = 0;
	int selSda = -1;
	int selScl = -1;

	count = pBPOParameters->m_nBusSubCount;
	for(i = 0; i < count; i++)
	{
		pSubItemA = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(i);
		id = pSubItemA->m_nItemChannel;
		index = m_comboSda.AddString(pSubItemA->m_strItemName);
		index = m_comboScl.AddString(pSubItemA->m_strItemName);
		m_comboSda.SetItemData(index,id);
		m_comboScl.SetItemData(index,id);
		if(id == m_nSdaChannel)selSda = i;
		if(id == m_nSclChannel)selScl = i;
		pSubItemA = NULL;
	}

	if(selSda == -1 || selScl == -1)
	{
		if(count < 2)
		{
			selSda = 0;
			selScl = 0;
		}
		else
		{
			selSda = 0;
			selScl = 1;
		}		
	}
	m_comboSda.SetCurSel(selSda);
	m_comboScl.SetCurSel(selScl);

	return; 
}

void CIICSetupPage1::InitPinNameArray()
{
	int i = -1;
	for(i = 0; i < 80; i++)
		m_strPinName[i].Empty();
}


int CIICSetupPage1::JudgeChannelExist(CBPOSubItem* pSubItem)
{
	int id = -2, value = -2;

	id =pSubItem->m_nItemChannel;

	if(m_strPinName[id].IsEmpty())
		value = id;

	return value;
}



bool CIICSetupPage1::DifferenceChannelExist()
{
	CBPOSubItem* pSubItemA = NULL;
	CBPOSubItem* pSubItemB = NULL;

//	CViewItem* pFirstViewItem = NULL;
//	CViewItem* pSecondViewItem = NULL;
	int count = -1 , id = -2, diff_count = 0, id2 = -2;
	int i = -1, j = -1;

	count = pBPOParameters->m_nBusSubCount;//m_pDoc->GetViewItemCount();
	if(count > 0) 
		diff_count = 1;

	for(i = 0; i < count; i++)
	{
			pSubItemA = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(i);
	//	pFirstViewItem = m_pDoc->GetViewItemAt(i);
	//	if(pFirstViewItem->IsBus())
		//	return true;
		id = pSubItemA->m_nItemChannel;//pFirstViewItem->GetIndexInChannel();
		for( j = i+1; j < count; j++)
		{
		//	pSecondViewItem = m_pDoc->GetViewItemAt(j);
			pSubItemB = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(j);
		//	if(pSecondViewItem->IsBus())
		//		return true;
			id2 = pSubItemB->m_nItemChannel;//pSecondViewItem->GetIndexInChannel();
			if(id != id2)
				diff_count++;
			if(diff_count > 1 )
				return true;
		}
		if(diff_count > 1 )
			return true;
	}
	if(diff_count > 1 )
		return true;

	return false;
}

int CIICSetupPage1::TransformChannelIndexToComboBoxIndex(int ch_index)
{
	if( ch_index == -1 )
		return 0;

	int i = -1 , id = -1 , str_index = -1, rtn_value = -2;
	int count =pBPOParameters->m_nBusSubCount;// m_pDoc->GetViewItemCount();
	CBPOSubItem* pSubItem = NULL;
	CString pin_name;
	pin_name.Empty();
	
	if(count > 0)
	{
		for(i = 0; i < count; i++)
		{
			pSubItem = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(i);
			id =pSubItem->m_nItemChannel ;
			if(ch_index == id)
			{
				pin_name = pSubItem->m_strItemName;
				str_index = m_comboSda.FindString(-1,pin_name);
				if(str_index != CB_ERR )
				{
					rtn_value = str_index;
					break;
				}
			}
		}
	}
	return rtn_value;
}

/* Setup to Default Function */
void CIICSetupPage1::DefaultValue()
{
	DefaultSelectChannel();
	DefaultColor();
	DefaultBus();

}
void CIICSetupPage1::DefaultBus()
{
	m_edtBusName.SetWindowText(pBPOParameters->m_strBusName);

}

void CIICSetupPage1::DefaultColor()
{
	COLORREF clrStart  = DEFAULT_START_COLOR;
	COLORREF clrRead = DEFAULT_READ_COLOR;
	COLORREF clrWrite = DEFAULT_WRITE_COLOR;
	COLORREF clrData = DEFAULT_DATA_COLOR;
	COLORREF clrAck = DEFAULT_ACK_COLOR;
	COLORREF clrEnd = DEFAULT_END_COLOR;

	m_clrbtnStart.SetFaceColor(clrStart);
	m_clrbtnRead.SetFaceColor(clrRead);
	m_clrbtnWrite.SetFaceColor(clrWrite);
	m_clrbtnData.SetFaceColor(clrData);
	m_clrbtnAck.SetFaceColor(clrAck);
	m_clrbtnEnd.SetFaceColor(clrEnd);
    m_clrbtnREGADDR.SetFaceColor(RGB(43,207,255));
	m_clrbtnREGADDR.ReDrawButton();
	m_clrbtnStart.ReDrawButton();
	m_clrbtnRead.ReDrawButton();
	m_clrbtnWrite.ReDrawButton();
	m_clrbtnData.ReDrawButton();
	m_clrbtnAck.ReDrawButton();
	m_clrbtnEnd.ReDrawButton();


	COLORREF clrNAck = DEFAULT_NACK_COLOR;
	COLORREF clrAddress = DEFAULT_ADDRESS_COLOR;
	
	m_clrbtnAddress.SetFaceColor(clrAddress);
	m_clrbtnNAck.SetFaceColor(clrNAck);

	m_clrbtnAddress.ReDrawButton();
	m_clrbtnNAck.ReDrawButton();

	m_clrbtnDataAck.SetFaceColor(DEFAULT_DATAACK_COLOR);
	m_clrbtnDataNack.SetFaceColor(DEFAULT_DATANACK_COLOR);
	m_clrbtnDataAck.ReDrawButton();
	m_clrbtnDataNack.ReDrawButton();

}


void CIICSetupPage1::OnIicCustom() 
{
	// TODO: Add your control notification handler code here
	UINT ID;
	switch(pBPOParameters->m_nLanguage)
	{		
	case 1:
		ID=IDD_IIC_SETUP_CUSTOM_SI;  
		break;
	case 2:
		ID=IDD_IIC_SETUP_CUSTOM_TR;  
		break;
	case 3:
		ID=IDD_IIC_SETUP_CUSTOM;  //english
		break;
	default:
		ID=IDD_IIC_SETUP_CUSTOM;
		break;
	}
	CIICSetupCustomDlg I2C_Custom(ID);
	I2C_Custom.DoModal();
}

int CIICSetupPage1::GetListChannelID(CString name)
{
	int i = -1;
	int count = pBPOParameters->m_nBusSubCount;//m_pDoc->GetViewItemCount();

	CBPOSubItem* pSubItem = NULL;
	
	if(count > 0)
	{
		for(i = 0; i < count; i++)
		{
			pSubItem = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(i);
			//pViewItem = (CViewItem*)m_pDoc->GetViewItemAt(i);
		//	if(pViewItem->IsBus())
		//		continue;
			if( name == pSubItem->m_strItemName)//pViewItem->GetName() 
				return pSubItem->m_nItemChannel;//pViewItem->GetIndexInChannel();
		}
	}

return -2;	//get channel id fail
}

void CIICSetupPage1::OnSelchangeIicComboSda() 
{
	// TODO: Add your control notification handler code here
/*	int sda=-1,scl=-1,before_sda = -1 , before_scl = -1;
	sda = m_comboSda.GetCurSel();
	scl = m_comboScl.GetCurSel();
	if(sda == scl)
	{
		AfxMessageBox(MessageStringTable(IDS_SDA_SCL_EN));
	}*/
}

void CIICSetupPage1::OnSelchangeIicComboScl() 
{
	// TODO: Add your control notification handler code here
/*	int sda=-1,scl=-1,before_sda = -1 , before_scl = -1;
	sda = m_comboSda.GetCurSel();
	scl = m_comboScl.GetCurSel();
	if(sda == scl)
	{
		AfxMessageBox(MessageStringTable(IDS_SCL_SDA_EN));
	}*/
}

void CIICSetupPage1::DefaultSelectChannel()
{
	if(DifferenceChannelExist() == true)
	{
		int count = 0;
		int selSda = -1;
		int selScl = -1;
		
		count = pBPOParameters->m_nBusSubCount;
		if(count < 2)
		{
			selSda = 0;
			selScl = 0;
		}
		else
		{
			selSda = 0;
			selScl = 1;
		}
		m_comboSda.SetCurSel(selSda);
		m_comboScl.SetCurSel(selScl);
	}
}

bool CIICSetupPage1::StoreSelectChannel()
{
	int sda_sel = 0;
	int scl_sel = 0;
	sda_sel = m_comboSda.GetCurSel();
	if(sda_sel == -1)
	{
		AfxMessageBox(IDS_SCL_SDA_EN);
		return false;
	}
	scl_sel = m_comboScl.GetCurSel();
	if(scl_sel == -1)
	{
		AfxMessageBox(IDS_SDA_SCL_EN);
		return false;
	}
	if(sda_sel == scl_sel)
	{
		AfxMessageBox(MessageStringTable(IDS_SCL_SDA_EN));
		return false;
	}
	
	iicparamdata.SdaNameIndex=m_comboSda.GetItemData(sda_sel);
	iicparamdata.SclNameIndex=m_comboScl.GetItemData(scl_sel);
	
	return true;
}

void CIICSetupPage1::StoreColor()
{
	COLORREF clrStart= m_clrbtnStart.GetFaceColor();
	COLORREF clrRead= m_clrbtnRead.GetFaceColor();
	COLORREF clrWrite= m_clrbtnWrite.GetFaceColor();
	COLORREF clrAck= m_clrbtnAck.GetFaceColor();
	COLORREF clrData= m_clrbtnData.GetFaceColor();
	COLORREF clrEnd= m_clrbtnEnd.GetFaceColor();
	COLORREF clrAddress=m_clrbtnAddress.GetFaceColor();
	COLORREF clrNack=m_clrbtnNAck.GetFaceColor();
	iicparamdata.clrStart = clrStart;
	iicparamdata.clrRead = clrRead;
	iicparamdata.clrWrite = clrWrite;
	iicparamdata.clrAck = clrAck;
	iicparamdata.clrData = clrData;
	iicparamdata.clrEnd = clrEnd;
	iicparamdata.m_clrSpecBuscolor1=clrAddress;
	iicparamdata.m_clrSpecBuscolor2=clrNack;

	m_clrDataAck=m_clrbtnDataAck.GetFaceColor();
	iicparamdata.m_clrSpecBuscolor3=m_clrDataAck;

	m_clrDataNack=m_clrbtnDataNack.GetFaceColor();
	iicparamdata.m_clrSpecBuscolor4=m_clrDataNack;
	iicparamdata.m_clrSpecBuscolor5=m_clrbtnREGADDR.GetFaceColor();

}

void CIICSetupPage1::StoreBus()
{
	int len = m_edtBusName.GetWindowTextLength();
	char* name = new char[len+1];
	m_edtBusName.GetWindowText(name,len+1);
	m_strBusName = name;
	delete name;

	if(!m_strBusName.IsEmpty())
		iicparamdata.SetBusName(m_strBusName);
	else
		AfxMessageBox(IDS_UNEMPTY);
	
}

void CIICSetupPage1::SetSdaChannel(int channel)
{
	m_nSdaChannel = channel;
}
void CIICSetupPage1::SetSclChannel(int channel)
{
	m_nSclChannel = channel;
}
int CIICSetupPage1::GetSdaChannel()
{
	return m_nSdaChannel;
}
int CIICSetupPage1::GetSclChannel()
{
	return m_nSclChannel;
}


void CIICSetupPage1::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	// TODO: Add your message handler code here
	
	// Do not call CDialog::OnPaint() for painting messages
}



/////////////////////////////////////////////////////////////////////////////
// CIICSetupPage1 message handlers
int  CIICSetupPage1::TransforComboBoxIndexToChannelIndex(int ComboBoxindex)
{
	if( ComboBoxindex == -1 )
		return 0;

	int i = -1 , id = -1 , str_index = -1, rtn_value = -2;
	int count =pBPOParameters->m_nBusSubCount;
	CBPOSubItem* pSubItem = NULL;
	CString pin_name;
	pin_name.Empty();
	
	if(count > 0)
	{
		for(i = 0; i < count; i++)
		{
			pSubItem = (CBPOSubItem*)pBPOParameters->m_pSubItemAry->GetAt(i);			
			pin_name = pSubItem->m_strItemName;
			if (pin_name==m_strPinName[ComboBoxindex])				
			{
				rtn_value =i;
				break;
			}
			
		}
	}
	return rtn_value;
}