#if !defined(AFX_IICSETUPCUSTOMDLG_H__5DAB7F45_C85F_49F0_8D74_6A4C6E965138__INCLUDED_)
#define AFX_IICSETUPCUSTOMDLG_H__5DAB7F45_C85F_49F0_8D74_6A4C6E965138__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IICSetupCustomDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CIICSetupCustomDlg dialog
#include "EditIicBitCount.h"
#include "EditIicComponentName.h"
#include "PlugIIC.h"


class CIICSetupCustomDlg : public CDialog
{
private:
	//IICBus* m_pI2C;
	CString m_strAddressName;
	CString m_strDataName;
    CString m_strREGADDRName;

	bool m_berror_flag;
	BOOL m_bReadWriteActive;
//	BOOL m_nAddressLeftShift;
	int m_nAddressBitCount;
	int m_nREGADDRBitCount;
	int m_nDataBitCount;
	int m_nReadLevel;
	int m_nAckLevel;

public:	
	CIICSetupCustomDlg(int ID,CWnd* pParent = NULL);   // standard constructor


private:
	//Initialtion
	void InitI2CParameter();
	void InitAddressItem();
	void InitDataItem();
	void InitReadLevel();
	void InitAckLevel();
	void InitReadWriteChk();
	void InitREGADDRItem();

	//Default
	void DefaultReadLevel();
	void DefaultAckLevel();
	void DefaultAddressItem();
	void DefaultDataItem();
	void DefaultREGADDRItem();

	//Store
	void StoreReadLevel();
	void StoreAckLevel();
	void StoreAddressItem();
	void StoreDataitem();
    void StoreREGADDRitem();
	//Get setup parameter

// Dialog Data
	//{{AFX_DATA(CIICSetupCustomDlg)
	enum { IDD = IDD_IIC_SETUP_CUSTOM };
	CEditIicBitCount	m_edtDataBitCount;
	CEditIicBitCount	m_edtAddressBitCount;
	CEditIicBitCount    m_edtREGADDRBitCount;
	CEditIicComponentName	m_edtDataName;
	CEditIicComponentName	m_edtAddressName;
	CEditIicComponentName   m_edtREGADDRName;
	BOOL	m_bREGADDRChk;
	BOOL	m_bReadWriteChk;
	BOOL	m_bNackChk;
	BOOL	m_bAddressLeftShift;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIICSetupCustomDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CIICSetupCustomDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnIicLevelRh();
	afx_msg void OnIicLevelRl();
	afx_msg void OnIicLevelAckh();
	afx_msg void OnIicLevelAckl();
	afx_msg void OnIicCustomDefault();
	virtual void OnOK();
	afx_msg void OnIicCustomRwChk();
	afx_msg void OnIicCustomAddShiftChk();
	afx_msg void OnIicCustomNackChk();
	afx_msg void OnIicCustomREGADDRChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IICSETUPCUSTOMDLG_H__5DAB7F45_C85F_49F0_8D74_6A4C6E965138__INCLUDED_)
